import { query } from './query.js'
import {
  createWorld,
  Types,
  defineComponent,
  defineQuery,
  addEntity,
  addComponent,
  pipe,
} from 'bitecs'

const Edge = { from: Types.eid, to: Types.eid }
const Fox = defineComponent()
const Knows = defineComponent(Edge)
const Bot = defineComponent()

const components = {
  Fox,
  Bot,
  Knows
}

const world = createWorld()
world.components = components

const rown = addEntity(world)
addComponent(world, Fox, rown)

const cynn = addEntity(world)
addComponent(world, Bot, cynn)

const edge = addEntity(world)
addComponent(world, Knows, edge)
Knows.from[edge] = rown
Knows.to[edge] = cynn

//const q = query(world, '(:Fox)')
//q(world).forEach(eid => console.log(eid, 'has Fox!'))

const q2 = query(world, '(rawran:Fox)-[:Knows]->(cynnnnnnnn:Bot)')
q2(world).forEach(eid => console.log(eid))


