export class Result {
  constructor(value, error) {
    this.value = value
    this.error = error
  }

  static Ok(value) {
    return new Result(value, null)
  }

  static Err(error) {
    return new Result(null, error)
  }

  isOk() {
    return this.error === null
  }

  isErr() {
    return !this.isOk()
  }

  map(fn) {
    if (this.isOk()) {
      return Result.Ok(fn(this.value))
    } else {
      return this
    }
  }

  flatMap(fn) {
    if (this.isOk()) {
      return fn(this.value)
    } else {
      return this
    }
  }
}


